import es,dnd,popuplib,spe,gamethread,cmdlib,random
from dnd import dnd

def load():
    spe.registerPreHook("player_spawn", pre_spawn)
    cmdlib.registerClientCommand('!escape', escape, 'Kobold Ability - Flee from battle')

    Human_Info = popuplib.create('Kobold Info')
    Human_Info.addline('Kobold Race Information:')
    Human_Info.addline(' 10% Decreased Damage')
    Human_Info.addline(' -10 Health')
    Human_Info.addline(' !escape - Flee from battle (cool down)')
    Human_Info.addline(' Health Regeneration')
    Human_Info.addline('-> 9. Main Menu')
    Human_Info.submenu(9, 'main_menu')
    
def unload():
    popuplib.delete('Kobold Info')
    cmdlib.unregisterClientCommand('!escape')
    spe.unregisterPreHook("player_spawn", pre_spawn)
    
def escape(userid, args):
    if dnd.Player(userid).alive() and dnd.Player(userid).getRace() == 'Kobold':
        if es.ServerVar('allow_escape') == '1':
            if not dnd.Temp(userid).get('escape cool down'):
                dnd.Temp(userid).add('escape cool down', 1)
                gamethread.delayedname(3, 'dndtick', dnd.Temp(userid).add, ('escape cool down', -1))
                es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", "%s,%s,300"%(random.choice([300,-300]), random.choice([300,-300])))
            else:
                dnd.dndTell(userid, 'You must wait to use that ability')
        else:
            dnd.dndTell(userid, 'You must wait 8 seconds from round start to use that ability')
            
def round_start(ev):
    es.set('allow_escape',0)
    gamethread.delayedname(8, 'dndtick', allowescape)
    
def allowescape():
    es.set('allow_escape',1)
    
def pre_spawn(ev):
    if dnd.Player(ev['userid']).getRace() == 'Kobold':
        dnd.Temp(ev['userid']).add('health', -10)
        dnd.Temp(ev['userid']).add('escape cool down', 0)
        
def player_spawn(ev):
    if dnd.Player(ev['userid']).getRace() == 'Kobold' and dnd.Player(ev['userid']).alive():
        dnd.Temp(ev['userid']).set('escape cool down', 0)
        dnd.regen(ev['userid'], 3, 1)
        
def player_hurt(ev):
    if dnd.Player(ev['attacker']).getRace() == 'Kobold':
        dnd.heal(ev['userid'], int(ev['dmg_health']) * .1)
        